﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System.Windows.Forms;

namespace Library
{
    public partial class BaseCodeForm : Form
    {
        public BaseCodeForm()
        {
            InitializeComponent();
        }

        public virtual long AddRecord()
        {
            // ----- Prompt to add a new record. Return the ID
            //       when added, or -1 if cancelled.
            return -1L;
        }

        public virtual bool CanUserAdd()
        {
            // ----- Check the security of current user to see
            //       if adding is allowed.
            return false;
        }

        public virtual bool CanUserEdit()
        {
            // ----- Check the security of the user to see
            //       if editing is allowed.
            return false;
        }

        public virtual bool CanUserDelete()
        {
            // ----- Check the security of the user to see
            //       if deleting is allowed.
            return false;
        }

        public virtual bool DeleteRecord(long recordID)
        {
            // ----- Prompt the user to delete a record.
            //       Return True on delete.
            return false;
        }

        public virtual long EditRecord(long recordID)
        {
            // ----- Prompt the user to edit the record. Return the
            //       record's ID if saved, or -1 on cancel.
            return -1L;
        }

        public virtual void FillListWithRecords(ListBox destList, ref bool exceededMatches)
        {
            // ----- Fill a ListBox control with existing records.
        }

        public virtual string FormatRecordName(long recordID)
        {
            // ----- Return the formatted name of a single record.
            return "";
        }

        public virtual string GetEditDescription()
        {
            // ----- Return a description of this editor.
            return "";
        }

        public virtual string GetEditTitle()
        {
            // ----- Return the title-bar text for this editor.
            return "";
        }

        public virtual void SearchForRecord(ListBox destList, ref bool exceededMatches)
        {
            // ----- Prompt the user to search for a record.
            return;
        }

        public virtual bool UsesSearch()
        {
            // ----- Does this editor support searching?
            return false;
        }
    }
}
