﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

namespace Library
{
    public enum ReportItemEnum: int
    {
        // ----- The type of item in the report select list.
        GroupLabel = 0,
        BuiltInCheckedOut = 1,
        BuiltInOverdue = 2,
        BuiltInMissing = 3,
        BuiltInFinesOwed = 4,
        BuiltInStatistics = 5,
        ExeProgram = 6,
        UrlProgram = 7
    }

    public class ReportItem
    {
        // ----- Instance of report selection items used
        //       in the ReportSelect form.
        public ReportItemEnum ItemType;
        public int Indent;         // Indent level. Starts with 0.
        public string DisplayText;
        public string ReportPath; // ExeProgram / UrlProgram only
        public string ReportArgs; // ExeProgram only
        public string Description;

        public override string ToString()
        {
            // ----- Display an indented string. Prepend with spaces.
            return (new string(' ', Indent * 5)) + DisplayText;
        }
    }
}
