﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Windows.Forms;
using Microsoft.Reporting.WinForms;
using static Library.General;

namespace Library
{
    public partial class ReportBuiltinViewer : Form
    {
        private object StoreDataTable;

        public ReportBuiltinViewer()
        {
            InitializeComponent();
        }

        public void StartReport(string whichReport, string whichDataSchema, object whichData)
        {
            // ----- Run one of the built-in reports. whichReport is the name of
            //       the RDLC report file, in the format "Library.xxx.rdlc."
            //       whichDataSchema provides the name of the schema to use,
            //       in the format "Library_xxx." whichDataSet is the actual
            //       data to link to the report, which must match the schema.
            ReportDataSource customDataSource = new ReportDataSource();

            // ----- Connect the viewer, the report, and the data.
            ReportContent.LocalReport.ReportEmbeddedResource = whichReport;
            customDataSource.Name = whichDataSchema;
            customDataSource.Value = whichData;
            ReportContent.LocalReport.DataSources.Add(customDataSource);

            // ----- Display the report.
            StoreDataTable = whichData;
            this.Show();
        }

        private void ReportBuiltinViewer_FormClosing(object sender, FormClosingEventArgs e)
        {
            // ----- Get rid of the data.
            if (StoreDataTable is IDisposable)
                ((IDisposable)StoreDataTable).Dispose();
        }

        private void ReportBuiltinViewer_Load(object sender, EventArgs e)
        {
            // ----- Generate and display the report.
            ReportContent.SetDisplayMode(DisplayMode.PrintLayout);
            ReportContent.ZoomMode = ZoomMode.Percent;
            ReportContent.ZoomPercent = 100;
            ReportContent.RefreshReport();
        }
    }
}
