﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Windows.Forms;
using static Library.General;

namespace Library
{
    public partial class ItemLimit : Form
    {
        public ItemLimit()
        {
            InitializeComponent();
        }

        public string PromptUser()
        {
            // ----- Prompt the user for search criteria.
            this.ShowDialog();
            if (this.DialogResult == DialogResult.OK)
            {
                if (OptionAll.Checked == true)
                    return "*";
                else
                    return ItemTitle.Text.Trim();
            }
            else
            {
                return "";
            }
        }

        private void ItemTitle_Enter(object sender, EventArgs e)
        {
            // ----- Highlight the entire text.
            ItemTitle.SelectAll();
        }

        private void ItemTitle_TextChanged(object sender, EventArgs e)
        {
            // ----- Make this a limited search.
            OptionByTitle.Checked = (ItemTitle.Text.Trim().Length != 0);
            OptionAll.Checked = !OptionByTitle.Checked;
        }

        private void ActOK_Click(object sender, EventArgs e)
        {
            // ----- For name searches, require a value.
            if ((OptionByTitle.Checked == true) & (ItemTitle.Text.Trim().Length == 0))
            {
                MessageBox.Show("When searching by title, please supply a search text.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            this.DialogResult = DialogResult.OK;
        }

        private void ItemLimit_KeyDown(object sender, KeyEventArgs e)
        {
            // ----- F1 shows online help.
            if (e.KeyCode == Keys.F1)
                OnlineHelp(this, "ItemLimit.htm");
        }
    }
}
