﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Windows.Forms;
using static Library.General;

namespace Library
{
    public partial class PublisherLimit : Form
    {
        public PublisherLimit()
        {
            InitializeComponent();
        }

        public string PromptUser()
        {
            // ----- Prompt the user for search criteria.
            this.ShowDialog();
            if (this.DialogResult == DialogResult.OK)
            {
                if (OptionAll.Checked == true)
                    return "*";
                else
                    return PublisherName.Text.Trim();
            }
            else
            {
                return "";
            }
        }

        private void PublisherName_Enter(object sender, EventArgs e)
        {
            // ----- Highlight the entire text.
            PublisherName.SelectAll();
        }

        private void PublisherName_TextChanged(object sender, EventArgs e)
        {
            // ----- Make this a limited search.
            OptionByName.Checked = (PublisherName.Text.Trim().Length != 0);
            OptionAll.Checked = !OptionByName.Checked;
        }

        private void ActOK_Click(object sender, EventArgs e)
        {
            // ----- For name searches, require a value.
            if ((OptionByName.Checked == true) &
                (PublisherName.Text.Trim().Length == 0))
            {
                MessageBox.Show("When searching by name, please supply a search text.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            this.DialogResult = DialogResult.OK;
        }

        private void PublisherLimit_KeyDown(object sender, KeyEventArgs e)
        {
            // ----- F1 shows online help.
            if (e.KeyCode == Keys.F1)
                OnlineHelp(this, "PublisherLimit.htm");
        }
    }
}
