﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace ForeignNames
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void TextBox1_TextChanged(object sender, EventArgs e)
        {
            // ----- Force a redraw.
            PictureBox1.Invalidate();
        }

        private void PictureBox1_Paint(object sender, PaintEventArgs e)
        {
            // ----- Draw the blank background.
            e.Graphics.Clear(SystemColors.Window);
            e.Graphics.DrawRectangle(SystemPens.InactiveCaption, 0, 0,
                PictureBox1.Width - 1, PictureBox1.Height - 1);

            // ----- Change the orientation of the display.
            GraphicsState saveState = e.Graphics.Save();
            Matrix mirrorMatrix = new Matrix(1, 0, 0, -1, 0, PictureBox1.Height);
            e.Graphics.Transform = mirrorMatrix;

            // ----- Draw the text.
            e.Graphics.DrawString(TextBox1.Text, TextBox1.Font,
                SystemBrushes.WindowText, 1, 4);

            // ----- Put everything back.
            e.Graphics.Restore(saveState);
        }
    }
}
