﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            // ----- Create an instance of a hello decoder and
            //       have it show the message.
            HelloStuff.SayHello helloDecoder;

            helloDecoder = new HelloStuff.SayHello("!iqwtB ,tqqjM", true);
            helloDecoder.MessageDecoded += ReceiveDecodedMessage;
            helloDecoder.DecodeMessage(-5);
            helloDecoder.ReportMessage();
        }

        private void ReceiveDecodedMessage(string decodedMessage)
        {
            // ----- Show the decoded message.
            MessageBox.Show(decodedMessage);
        }
    }
}

namespace HelloStuff
{
    internal class SayHello
    {
        private string SecretMessage;
        private bool ReverseFlag;
        private bool Decoded;

        public delegate void MessageDecodedDelegate(string decodedMessage);
        public event MessageDecodedDelegate MessageDecoded;
        protected virtual void OnMessageDecoded(string decodedMessage)
        {
            // ----- Fire an event for the caller.
            MessageDecodedDelegate theCaller = MessageDecoded;
            if (theCaller != null)
                MessageDecoded(decodedMessage);
        }

        public SayHello(string codedMessage, bool reverseIt)
        {
            // ----- Save the secret message. It will be decoded later.
            SecretMessage = codedMessage;
            ReverseFlag = reverseIt;
            Decoded = false;
        }

        public void DecodeMessage(int rotationFactor)
        {
            // ----- The original message was coded, Rotate each character
            //       through the alphabet by the specified number of times
            //       to get the true value.
            string result;
            char oneChar;
            int charValue;

            // ----- Don't decode twice.
            if (Decoded == true)
                return;

            // ----- Process each character.
            result = "";
            for (int counter = 0; counter < SecretMessage.Length; counter++)
            {
                oneChar = SecretMessage[counter];
                if (char.IsLower(oneChar) == true)
                {
                    // ----- Rotate the character. Convert it to an integer,
                    //       rotate it, then convert it back.
                    charValue = (int)oneChar - (int)'a';
                    charValue = (charValue + rotationFactor + 26) % 26;
                    oneChar = (char)(charValue + (int)'a');
                    result += oneChar;
                }
                else if (char.IsUpper(oneChar) == true)
                {
                    // ----- Rotate the character. Convert it to an integer,
                    //       rotate it, then convert it back.
                    charValue = (int)oneChar - (int)'A';
                    charValue = (charValue + rotationFactor + 26) % 26;
                    oneChar = (char)(charValue + (int)'A');
                    result += oneChar;
                }
                else
                {
                    // ----- No special translation on this character.
                    result += oneChar;
                }
            }

            // ----- Store the converted value.
            SecretMessage = result;
            Decoded = true;
        }

        public void ReportMessage()
        {
            // ----- Fire an event for the caller.
            if (ReverseFlag == true)
                OnMessageDecoded(new string(SecretMessage.Reverse().ToArray()));
            else
                OnMessageDecoded(SecretMessage);
        }
    }
}
