﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;

namespace Library
{
    public class ListItemData
    {
		public string ItemText;
		public long ItemData;
		public char TextCode;
        private bool UseChar;

		public ListItemData(string displayText, long itemID)
		{
			// ----- Initialize the record for long codes.
			ItemText = displayText;
			ItemData = itemID;
            TextCode = '\0';
            UseChar = false;
		}

		public ListItemData(string displayText, char itemCode)
		{
			// ----- Initialize the record for char codes.
			ItemText = displayText;
            ItemData = -1L;
            TextCode = itemCode;
            UseChar = true;
		}

		public override string ToString()
		{
			// ----- Display the basic item text.
			return ItemText;
		}

		public override bool Equals(object obj)
		{
			// ----- Allow IndexOf() and Contains() searches by ItemData.
			if ((UseChar == false) & (obj is long))
				return (Convert.ToInt64(obj) == ItemData);
			else if ((UseChar == true) & (obj is char))
				return (Convert.ToChar(obj) == TextCode);
			else
				return base.Equals(obj);
		}

        public override int GetHashCode()
        {
            // ----- Use the data or code value as the hash.
            if (UseChar == false)
                return this.ItemData.GetHashCode();
            else
                return this.TextCode.GetHashCode();
        }
    }
}
