﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace SimpleReport
{
    public partial class CustomReport : Form
    {
        public CustomReport()
        {
            InitializeComponent();
        }

        private void ReportViewer1_Load(object sender, EventArgs e)
        {
            // ----- Link to the RDLC report design.
            this.ReportViewer1.LocalReport.ReportEmbeddedResource =
                "SimpleReport.Report2.rdlc";

            // ----- Create a fake table of fake records.
            List<FakeActivityRecord> fakeSource = new List<FakeActivityRecord>();

            // ----- Add each of the fake records.
            fakeSource.Add(new FakeActivityRecord(1, "Breakfast"));
            fakeSource.Add(new FakeActivityRecord(2, "Lunch"));
            fakeSource.Add(new FakeActivityRecord(3, "Dinner"));

            // ----- Build a new data source. Remember, it must have
            //       the same name.
            Microsoft.Reporting.WinForms.ReportDataSource fakeReportSource =
                new Microsoft.Reporting.WinForms.ReportDataSource();
            fakeReportSource.Name = "SimpleReport_FakeActivityRecord";
            fakeReportSource.Value = fakeSource;

            // ----- Connect the data source to the report, and we're done.
            this.ReportViewer1.LocalReport.DataSources.Add(fakeReportSource);
            this.ReportViewer1.RefreshReport();
        }
    }
}
