﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SimpleReport
{
    public partial class StandardReport : Form
    {
        public StandardReport()
        {
            InitializeComponent();
        }

        private void StandardReport_Load(object sender, EventArgs e)
        {
            // ----- Show the report.
            this.ReportViewer1.RefreshReport();
        }

        public void StartReport(string whichMethod)
        {
            if (whichMethod == "REAL")
            {
                // ----- Run the real report.
                this.ActivityTableAdapter.Fill(this.LibraryDataSet.Activity);
            }
            else
            {
                // ----- Run the custom report. Create a fake table
                //       of fake records.
                List<FakeActivityRecord> fakeSource = new List<FakeActivityRecord>();

                // ----- Add each of the fake records.
                fakeSource.Add(new FakeActivityRecord(1, "Do some work"));
                fakeSource.Add(new FakeActivityRecord(2, "Take a nap"));
                fakeSource.Add(new FakeActivityRecord(3, "Write a program"));

                // ----- The report was already bound to the true
                //       data source. Delete it.
                this.ReportViewer1.LocalReport.DataSources.Clear();

                // ----- Build a new data source. Remember, it must have
                //       the same name.
                Microsoft.Reporting.WinForms.ReportDataSource fakeReportSource =
                    new Microsoft.Reporting.WinForms.ReportDataSource();
                fakeReportSource.Name = "LibraryDataSet_Activity";
                fakeReportSource.Value = fakeSource;

                // ----- Connect the data source to the report, and we're done.
                this.ReportViewer1.LocalReport.DataSources.Add(fakeReportSource);
            }
            this.Show();
        }
    }
}
