﻿// ----- The Library Project
//       Start-to-Finish Visual C# 2015
//       Copyright (c) 2016 by Tim Patrick

using System;
using System.Reflection;
using System.Windows.Forms;

namespace Library
{
    public partial class Splash : Form
    {
        private const int DisplaySeconds = 2;

        private DateTime OpenTime;

        public Splash()
        {
            this.OpenTime = DateTime.Now;
            InitializeComponent();
        }

        public void ShowAwhile()
        {
            // ----- Show the form for up to two seconds.
            DateTime currentTime = DateTime.Now;
            if (currentTime >= this.OpenTime.AddSeconds(DisplaySeconds))
                return;
            System.Threading.Thread.Sleep(this.OpenTime.AddSeconds(DisplaySeconds) - currentTime);
            return;
        }

        private void Splash_Load(object sender, EventArgs e)
        {
            // ----- Update the version number.
            Assembly currentAssembly;
            Version versionInfo;

            // ----- Show the version details.
            currentAssembly = Assembly.GetEntryAssembly();
            if (currentAssembly == null)
                currentAssembly = Assembly.GetCallingAssembly();
            versionInfo = currentAssembly.GetName().Version;
            ProgramVersion.Text = string.Format("Version {0}.{1} Revision {2}",
                versionInfo.Major, versionInfo.Minor, versionInfo.Revision);

            // ----- Show the copyright information.
            object[] attrSet = currentAssembly.GetCustomAttributes(
                typeof(AssemblyCopyrightAttribute), inherit:true);
            if (attrSet.Length != 0)
                ProgramCopyright.Text =
                    ((AssemblyCopyrightAttribute)attrSet[0]).Copyright;
        }
    }
}
